/* C-code to create Java native method */

#define INCL_PM
#include <os2.h>
#include <string.h>
#include <javastring.h>
#include "NativeClass1.h"

/* Global data ------------------------------ */

HINI hProf;
int  iKeyCt, iAppCt;
int  iSet;
char szEof[]="eof";
long lKeyLen, lAppLen;
char appBuf[8192];
char keyBuf[4096];
char profVal[256];

/*boolean*/ long NativeClass1_profOpen(struct HNativeClass1 *s,long wProf)
{
   iKeyCt=0;
   iAppCt=0;
   lKeyLen=0;
   lAppLen=0;
   hProf=0;

   switch (wProf) {
   case 1:
      hProf = HINI_SYSTEM;
      return (long) 1;
      break;
   case 2:
      hProf = HINI_USER;
      return (long) 1;
      break;
   default: 
      return (long) 0;
     break;
   } /* endswitch */
   return 0;
}

long NativeClass1_profApps(struct HNativeClass1 *s)
{ 
  unsigned long  ulLen;
  
  ulLen = PrfQueryProfileString(hProf,
                                NULL,
                                NULL,
                                NULL,
                                (PVOID) appBuf,
                                (LONG) sizeof(appBuf) );
  lAppLen = (long) ulLen;
  iAppCt = 0;
  return lAppLen;

}


long NativeClass1_profKeys(struct HNativeClass1 *s,struct Hjava_lang_String *p1)
{ 
  char szApp[256];
  unsigned long  ulLen;
  
  javaString2CString(p1, szApp, sizeof(szApp));

  ulLen = PrfQueryProfileString(hProf,
                                szApp,
                                NULL,
                                "not found",
                                (PVOID) keyBuf,
                                (LONG) sizeof(keyBuf) );
  lKeyLen = (long) ulLen;
  iKeyCt = 0;
  return lKeyLen;

}

struct Hjava_lang_String *NativeClass1_seqApp(struct HNativeClass1 *s)
{
   int myLen, iOff;

   if (iAppCt < lAppLen)
   {
      iOff = iAppCt;
      myLen = strlen(&appBuf[iAppCt]);
      iAppCt += (myLen+1);
      return makeJavaString(&appBuf[iOff], myLen);
   }
   else
      return makeJavaString(szEof, strlen(szEof));
}

struct Hjava_lang_String *NativeClass1_seqKey(struct HNativeClass1 *s)
{
   int myLen, iOff;

   if (iKeyCt < lKeyLen)
   {
      iOff = iKeyCt;
      myLen = strlen(&keyBuf[iKeyCt]);
      iKeyCt += (myLen+1);
      return makeJavaString(&keyBuf[iOff], myLen);
   }
   else
      return makeJavaString(szEof, strlen(szEof));
}

struct Hjava_lang_String *NativeClass1_qString(struct HNativeClass1 *s,
                                               struct Hjava_lang_String *p1,
                                               struct Hjava_lang_String *p2)
{ 
  char szApp[256], szKey[256];
  unsigned long  ulLen;
  
  javaString2CString(p1, szApp, sizeof(szApp));
  javaString2CString(p2, szKey, sizeof(szKey));

  ulLen = PrfQueryProfileString(hProf,
                                szApp,
                                szKey,
                                "not found",
                                (PVOID) profVal,
                                (LONG) sizeof(profVal) );

  if (ulLen > 0) {
     return makeJavaString(profVal, strlen(profVal));
  } else {
     return makeJavaString("not found", 9);
  } /* endif */

}


long NativeClass1_qInt(struct HNativeClass1 *s,
                       struct Hjava_lang_String *p1,
                       struct Hjava_lang_String *p2)
{ 
  char szApp[256], szKey[256];
  unsigned long  ulLen;
  LONG lValue;
  
  javaString2CString(p1, szApp, sizeof(szApp));
  javaString2CString(p2, szKey, sizeof(szKey));

  lValue = PrfQueryProfileInt(hProf,
                              szApp,
                              szKey,
                              0);

  return (long) lValue;

}


Hjava_lang_String * NativeClass1_c2(struct HNativeClass1 *s, struct Hjava_lang_String *p1)
{
   char ns[256];
   char fs[]="Hello from C-land ";

   strcpy(ns, fs);
   javaString2CString(p1, &ns[strlen(fs)], sizeof(ns));
   return makeJavaString(ns, strlen(ns));
}

